#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <stack>
#include <stdexcept>

using namespace std;

class komplex
{
	double re, im;
	friend ostream& operator<<(ostream& proud, komplex z);
	friend istream& operator>>(istream& proud, komplex &z);
public:
	komplex(double re, double im): re(re), im(im){}
};

// Vlastn opertor pro vstup
ostream& operator<<(ostream& proud, komplex z)
{
	int ka = proud.width();
	proud << setw(0);
	return proud << "(" << setw(ka)<< z.re <<", "<<setw(ka) << z.im<<")";
}

// vlastn opertor pro vstup
istream& operator>>(istream& proud, komplex &z)
{
	char c;
	proud >> ws >> c;
	if (c != '(') throw invalid_argument("chybn vstup");
	proud >> z.re >> ws >> c;
	if (c != ',') throw invalid_argument("chybn vstup");
	proud >> z.im >> ws >> c;
	if (c != ')') throw invalid_argument("chybn vstup");
	return proud;
}

// Vlastn manipultpor pro vpis 10 mezer
ostream& mezery(ostream& proud)
{
	return proud << "          ";
}

// manipultor pro vpis ve dvojkov soustav
struct binrka
{
	string vsledek;
	binrka(unsigned hodnota)
	{
		
		if (hodnota == 0)
		{
			vsledek = "0";
			return;
		}
		stack<char> zsobnk;
		while (hodnota)
		{
			zsobnk.push(char(hodnota % 2 + '0'));
			hodnota /= 2;
		}
		while (!zsobnk.empty())
		{
			vsledek += zsobnk.top();
			zsobnk.pop();
		}
	}
};

binrka dvojkov(unsigned n)
{
	return n;
}

ostream& operator << (ostream& proud, binrka b)
{
	return proud << b.vsledek;
}

int main()
{
	komplex z{ 3.14, 5.6 };
	cout << mezery << setw(10) << z << endl;
	cout << dvojkov(10) << endl;
	cin >> z;
	cout << z << endl;
}